'use strict';

exports.__esModule = true;

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var isFn = function isFn(test) {
  return typeof test === 'function';
};
var id = function id(Component) {
  return Component;
};

var Crate = function () {
  function Crate() {
    var fn = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : id;

    _classCallCheck(this, Crate);

    this.fn = fn;
    return this;
  }

  Crate.prototype.map = function map(fn) {
    return new Crate(fn(this.fn));
  };

  Crate.prototype.fold = function fold(fn) {
    return fn(this.fn);
  };

  Crate.prototype.compile = function compile() {
    var Component = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 'div';

    return this.fold(function (hoc) {
      return hoc(Component);
    });
  };

  Crate.prototype.hoc = function hoc(fn) {
    return this.map(function (hoc) {
      return function (Wrapped) {
        return hoc(fn(Wrapped));
      };
    });
  };

  Crate.of = function of(Component) {
    return new Crate(function (_) {
      return Component;
    });
  };

  return Crate;
}();

exports.default = Crate;
module.exports = exports['default'];